'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 17 January 2005 at 5:12:48 pm'!
TestCase subclass: #Exercise1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STExercises'!

!Exercise1 commentStamp: '<historical>' prior: 0!
Smalltalk course IRbuilder exercises!

TestCase subclass: #Exercise2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STExercises'!

!ContextPart class methodsFor: 'examples' stamp: 'omn 1/17/2005 17:11'!
tallyMethodCoverage: aBlock 
	"ContextPart tallyMethodCoverage: [3.14159 printString]"
	| tallies count |
	tallies := Dictionary new.
	thisContext sender
		runSimulated: aBlock
		contextAtEachStep: [:current | 
			count := tallies
						at: current
						ifAbsent: [Set new].
			count add: current pc.
			tallies at: current put: count].
	^ tallies keys
		collect: [:context | context -> (100 * (tallies at: context) size // context method endPC)]
! !

!ContextPart class methodsFor: 'examples' stamp: 'omn 1/17/2005 17:11'!
tallyMethods: aBlock
	"This method uses the simulator to count the number of calls on each method
	invoked in evaluating aBlock. Results are given in order of decreasing counts."
	| prev tallies |
	tallies _ Bag new.
	prev _ aBlock.
	thisContext sender
		runSimulated: aBlock
		contextAtEachStep:
			[:current |
			current == prev ifFalse: "call or return"
				[prev sender == nil ifFalse: "call only"
					[tallies add: current printString].
				prev _ current]].
	^tallies sortedCounts

	"ContextPart tallyMethods: [3.14159 printString]"! !


!Exercise1 methodsFor: 'testing' stamp: 'omn 1/17/2005 15:45'!
dotestReturnAdd
	self assert: (1 @ 2) returnSum = 3.
	self assert: (3 @ 4) returnSum = 7.
! !

!Exercise1 methodsFor: 'testing' stamp: 'omn 1/17/2005 16:21'!
testIntro
	self assert: self intro == 3! !

!Exercise1 methodsFor: 'testing' stamp: 'omn 1/17/2005 16:21'!
testPart1
	self assert: self part1 == 5040! !

!Exercise1 methodsFor: 'testing' stamp: 'omn 1/17/2005 16:21'!
testPart2
	self assert: (self part2: #(3 4)) == 5040! !

!Exercise1 methodsFor: 'testing' stamp: 'omn 1/17/2005 16:21'!
testPart3
	self assert: (self part3: 10) == 10! !

!Exercise1 methodsFor: 'testing' stamp: 'omn 1/17/2005 16:21'!
testPart4
	self assert: (self part4: 3@4) == 7! !

!Exercise1 methodsFor: 'testing' stamp: 'omn 1/17/2005 15:46'!
testPart5
	self part5.
	self dotestReturnAdd.
	self part5undo.! !

!Exercise1 methodsFor: 'exercises' stamp: 'omn 1/17/2005 12:09'!
intro
	"self new intro"
	| irMethod aCompiledMethod |
	irMethod := IRBuilder new rargs: #(#self );
				 pushTemp: #self;
				 send: #truncated;
				 returnTop;
				 ir.
	"receiver and args"
	aCompiledMethod := irMethod compiledMethod.
	^ aCompiledMethod valueWithReceiver: 3.5 arguments: #()! !

!Exercise1 methodsFor: 'exercises' stamp: 'omn 1/17/2005 15:10'!
part1
	"self new part1"
	| irMethod aCompiledMethod |
	irMethod := IRBuilder new rargs: #(#self );
				 pushLiteral: 3;
				 pushLiteral: 4;
				 send: #+;
				 send: #factorial;
				 returnTop;
				 ir.
	aCompiledMethod := irMethod compiledMethod.
	^ aCompiledMethod valueWithReceiver: nil arguments: #()! !

!Exercise1 methodsFor: 'exercises' stamp: 'omn 1/17/2005 15:10'!
part2: args
	"self new part2"
	| irMethod aCompiledMethod |
	irMethod := IRBuilder new rargs: #(#self #arg1 #arg2);
				 pushTemp: #arg1;
				 pushTemp: #arg2;
				 send: #+;
				 send: #factorial;
				 returnTop;
				 ir.
	aCompiledMethod := irMethod compiledMethod.
	^ aCompiledMethod valueWithReceiver: nil arguments: args! !

!Exercise1 methodsFor: 'exercises' stamp: 'omn 1/17/2005 15:09'!
part3: max
	"self new part3: 10"
	| irMethod aCompiledMethod |
	irMethod := IRBuilder new rargs: #(#self #max );
				 addTemp: #counter;
				 pushLiteral: 1;
				 storeTemp: #counter;
				 popTop;
				 jumpBackTarget: #loop;
				 pushLiteral: Transcript;
				 pushTemp: #counter;
				 send: #show:;
				 popTop;
				 pushLiteral: Transcript;
				 pushLiteral: ' ';
				 send: #show:;
				 popTop;
				 pushTemp: #counter;
				 pushTemp: #max;
				 send: #>=;
				 jumpAheadTo: #end if: true;
				 pushTemp: #counter;
				 pushLiteral: 1;
				 send: #+;
				 storeTemp: #counter;
				 popTop;
				 jumpBackTo: #loop;
				 jumpAheadTarget: #end;
				 pushLiteral: Transcript;
				 send: #cr;
				 popTop;
				 pushTemp: #counter;
				 returnTop;
				 ir.
	aCompiledMethod := irMethod compiledMethod.
	^ aCompiledMethod valueWithReceiver: nil arguments: (max)! !

!Exercise1 methodsFor: 'exercises' stamp: 'omn 1/17/2005 15:30'!
part4: anObject
	"self new part4: 3@4"
	
	^ self returnSumMethod valueWithReceiver: anObject arguments: #( )
! !

!Exercise1 methodsFor: 'exercises' stamp: 'omn 1/17/2005 15:40'!
part5
	"self new part5"
	
	Point methodDict at: #returnSum put: self returnSumMethod.! !

!Exercise1 methodsFor: 'exercises' stamp: 'omn 1/17/2005 15:43'!
part5undo
	"self new part5undo"
	
	Point methodDict removeKey: #returnSum ifAbsent: [] .! !

!Exercise1 methodsFor: 'exercises' stamp: 'omn 1/17/2005 15:30'!
returnSumMethod
	| irMethod aCompiledMethod |
	irMethod := IRBuilder new rargs: #(#self);
				 pushTemp: #self;
				 getField: 1;
				 pushTemp: #self;
				 getField: 2;
				 send: #+;
				 returnTop;
				 ir.
	aCompiledMethod := irMethod compiledMethod.
	^ aCompiledMethod! !


!Exercise2 methodsFor: 'exercises' stamp: 'omn 1/17/2005 16:19'!
methodCovered: aBlock 
	"self new methodCovered: [3.14159 printString]"
	^ ((ContextPart tallyMethods: aBlock)
		collect: [:next | next value]) asSortedCollection asArray! !

!Exercise2 methodsFor: 'exercises' stamp: 'omn 1/17/2005 16:10'!
numberOfBytecodeExecuted: aBlock 
	"self new numberOfBytecodeExecuted: [3.14159 printString]"
	^ (ContextPart tallyInstructions: aBlock)
		inject: 0
		into: [:subTotal :next | subTotal + next value]! !

!Exercise2 methodsFor: 'exercises' stamp: 'omn 1/17/2005 16:13'!
numberOfMethodsExecuted: aBlock 
	"self new numberOfMethodsExecuted: [3.14159 printString]"
	^ (ContextPart tallyMethods: aBlock) size! !

!Exercise2 methodsFor: 'testing' stamp: 'omn 1/17/2005 16:10'!
testPart1
	self assert: (self numberOfBytecodeExecuted: [3.14159 printString]) = 1029! !

!Exercise2 methodsFor: 'testing' stamp: 'omn 1/17/2005 16:14'!
testPart2
	self assert: (self numberOfMethodsExecuted: [3.14159 printString]) = 37! !

Point class removeSelector: #returnSum!

!Exercise2 reorganize!
('exercises' methodCovered: numberOfBytecodeExecuted: numberOfMethodsExecuted:)
('testing' testPart1 testPart2)
!

Exercise1 removeSelector: #ex11!
Exercise1 removeSelector: #ex12!
Exercise1 removeSelector: #ex12:!
Exercise1 removeSelector: #ex13!
Exercise1 removeSelector: #ex13:!
Exercise1 removeSelector: #ex14!
Exercise1 removeSelector: #part4!
Exercise1 removeSelector: #part5:!
Exercise1 removeSelector: #testAll!
Exercise1 removeSelector: #testEx11!
Exercise1 removeSelector: #testEx12!
Exercise1 removeSelector: #testEx13!
Exercise1 removeSelector: #testEx14!
Exercise1 removeSelector: #testReturnAdd!

!Exercise1 reorganize!
('testing' dotestReturnAdd testIntro testPart1 testPart2 testPart3 testPart4 testPart5)
('exercises' intro part1 part2: part3: part4: part5 part5undo returnSumMethod)
!

ContextPart class removeSelector: #numberOfBytecodeExecuted:!
